# std::filesystem::file_size

From cppreference.com
< cpp‎ | filesystem

Defined in header `<filesystem>` |  |
std::uintmax_t file_size( const std::filesystem::path& p ); std::uintmax_t file_size( const std::filesystem::path& p, std::error_code& ec ); | (1) | (since C++17)

Returns the size of the regular file `p`, determined as if by reading the `st_size` member of the structure obtained by POSIX stat (symlinks are followed)

Attempting to determine the size of a directory (as well as any other file that is not a regular file or a symlink) is treated as an error.

The non-throwing overload returns returns -1 on errors.

### Parameters

p | - | path to examine
ec | - | out-parameter for error reporting in the non-throwing overload

### Return value

The size of the file, in bytes.

### Exceptions

The overload that does not take a std::error_code& parameter throws filesystem_error on underlying OS API errors, constructed with `p` as the first argument and the OS error code as the error code argument. std::bad_alloc may be thrown if memory allocation fails. The overload taking a std::error_code& parameter sets it to the OS API error code if an OS API call fails, and executes ec.clear() if no errors occur. This overload has
`noexcept` specification:
noexcept

### Example

Run this code

    #include <iostream>
    #include <fstream>
    #include <filesystem>
    namespace fs = std::filesystem;
    int main()
    {
        fs::path p = fs::current_path() / "example.bin";
        std::ofstream(p).put('a'); // create file of size 1
        std::cout << "File size = " << fs::file_size(p) << '\n';
        fs::remove(p);

        try {
            fs::file_size("/dev"); // attempt to get size of a directory
        } catch(fs::filesystem_error& e) {
            std::cout << e.what() << '\n';
        }
    }

Possible output:

    File size = 1
    boost::filesystem::file_size: Operation not permitted: "/dev"

### See also

resize_file (C++17) | changes the size of a regular file by truncation or zero-fill (function)
space (C++17) | determines available free space on the file system (function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/filesystem/file_size&oldid=84770"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template